﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Windows;
using Infragistics.Windows.Controls;

namespace WpfApplication1
{
    class ViewModelMain : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

            
        private ObservableCollection<TabModel> _tabList;
        public ObservableCollection<TabModel> TabList
        {
            get { return _tabList; }
            set
            {
                _tabList = value;
                NotifyPropertyChanged("TabList"); 
            }
        }

        private ViewModelBase _selectedTabVM;
        public ViewModelBase SelectedTabViewModel
        {
            get { return _selectedTabVM; }
            set { _selectedTabVM = value; }
        }
        

        /// <summary>
        /// Initializes a new instance of the PVConfigurationMainViewModel class.
        /// </summary>
        public ViewModelMain()
        {
            TabList = new ObservableCollection<TabModel>();
            TabList.Add(new TabModel("View1", new UC1ViewModel()));
            TabList.Add(new TabModel("View2", new UC2ViewModel()));

            SelectedTabViewModel = TabList[0].ViewModel;
             
        }
    }

    public class TabModel
    {
        public TabModel(string tabname, ViewModelBase vm)
        {
            this.TabName = tabname;
            this.ViewModel = vm;
        }

        public string TabName { get; set; }
        public ViewModelBase ViewModel { get; set; }
    }

    public class WorkspaceTemplateSelector : DataTemplateSelector
    {
        public override DataTemplate SelectTemplate(object item, DependencyObject container)
        {
            TabModel vm = item as TabModel;
            XamTabControl tabControl = Utilities.GetAncestorFromType(container, typeof(XamTabControl), false) as XamTabControl;


            if (vm.TabName.Equals("View1"))
                return tabControl.Resources["UC1ViewModel"] as DataTemplate;
            else
                return tabControl.Resources["UC2ViewModel"] as DataTemplate;


        }
    }
    
}
